﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.WebEdition;
using ThinkGeo.MapSuite.Core;
using System.Configuration;

namespace Geosys.Prototypes.MapSuite.WebEdition.Pages.TestTemp
{


    public partial class TestMultiPoints : System.Web.UI.Page
    {

       

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                InitializeModuleCarto();
               
                
            }
        }

        #region Module Carto Initialisation

        private void InitializeModuleCarto()
        {
            InitializeInchedPerUnit();
            InitializeMapAppearance();
            InitializeBackgroundLayer();
            InitializeMapExtend();
            InitializeFeature();
            Map1.MapUnit = GeographyUnit.Meter;

        }

        #region Init Current Scale
        public const int DotsPerInch = 96;
        public Dictionary<string, double> inchesPerUnits;

        public void InitializeInchedPerUnit()
        {
            inchesPerUnits = new Dictionary<string, double>();
            inchesPerUnits.Add("DecimalDegree", 4374754);
            inchesPerUnits.Add("Feet", 12.0);
            inchesPerUnits.Add("Meter", 39.3701);
        }
        #endregion

        private void InitializeMapAppearance()
        {
            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
            Map1.MapTools.OverlaySwitcher.Enabled = false;
            Map1.MapTools.MouseCoordinate.Enabled = true;
            Map1.MapTools.PanZoomBar.Enabled = true;
            Map1.MapTools.ScaleLine.Enabled = true;
            Map1.MapTools.Logo.Enabled = true;
            Map1.EditOverlay.EditSettings.IsDraggable = true;
            Map1.EditOverlay.EditSettings.IsReshapable = true;
            Map1.EditOverlay.EditSettings.IsResizable = false;
            Map1.EditOverlay.EditSettings.IsRotatable = false;

            Map1.EditOverlay.Style.FillColor = GeoColor.SimpleColors.BrightYellow;
            Map1.EditOverlay.Style.OutlineColor = GeoColor.SimpleColors.Blue;
            Map1.EditOverlay.Style.OutlineWidth = 2;
        }

        private void InitializeBackgroundLayer()
        {
                GoogleOverlay gOverlay = new GoogleOverlay();
                gOverlay.Name = "Google Overlay";
                gOverlay.GoogleMapType = GoogleMapType.Hybrid;
                string sOverlayMapURL = ConfigurationManager.AppSettings["sOverlayMapURL"];
                gOverlay.JavaScriptLibraryUri = new Uri(sOverlayMapURL);
                gOverlay.IsBaseOverlay = true;
                Map1.CustomOverlays.Add(gOverlay);

        }

        private void InitializeMapExtend()
        {

        }


        private BaseShape ProjectGeometry(BaseShape shapeIn, string projIn, string projOut)
        {
            Proj4Projection proj4 = new Proj4Projection();

            proj4.InternalProjectionParametersString = projIn;
            proj4.ExternalProjectionParametersString = projOut;
            proj4.Open();

            BaseShape shapeOut = proj4.ConvertToExternalProjection(shapeIn);

            proj4.Close();
            return shapeOut;
        }



        #endregion



        private void InitializeFeature()
        {
            initialiseField();
            initialisePoints();
        }



        private void initialiseField()
        {


            //InMemoryFeatureLayer inMemoryFeature = new InMemoryFeatureLayer();
            //LayerOverlay layerOverlay = new LayerOverlay("");
            //layerOverlay.IsBaseOverlay = false;

            //inMemoryFeature.Open();
            //inMemoryFeature.FeatureSource.BeginTransaction();
            //inMemoryFeature.ZoomLevelSet.ZoomLevel14.DefaultAreaStyle.FillSolidBrush = new GeoSolidBrush(GeoColor.StandardColors.Blue);
            //inMemoryFeature.ZoomLevelSet.ZoomLevel14.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            //BaseShape bs = BaseShape.CreateShapeFromWellKnownData(FieldFactory.getWKTInGeometry());
            //if (!(bs is PointShape))
            //{
            //    BaseShape bs2 = ProjectGeometry(bs, Proj4Projection.GetEpsgParametersString(4326), Proj4Projection.GetGoogleMapParametersString());
            //    Feature feature = bs2.GetFeature();

            //    inMemoryFeature.FeatureSource.AddFeature(feature);
            //}

            //inMemoryFeature.FeatureSource.CommitTransaction();
            //inMemoryFeature.FeatureSource.Close();
            //layerOverlay.Layers.Add(inMemoryFeature);

            //Map1.CustomOverlays.Add(layerOverlay);
        }

        private void initialisePoints()
        {
            MultipointShape multipoint = MultipointShape.CreateShapeFromWellKnownData("MULTIPOINT(-68487.5773375 6085610.4431062, 293518.18855625 6085610.4431062, 293518.18855625 5655117.09988121)") as MultipointShape;
            // On vide la couche d’édition
            if (!Map1.EditOverlay.FeatureSource.IsOpen) Map1.EditOverlay.FeatureSource.Open();
            Map1.EditOverlay.FeatureSource.InternalFeatures.Clear();

            Map1.EditOverlay.FeatureSource.BeginTransaction();
            // On ajoute le multipolygone à la couche d’édition
            Map1.EditOverlay.FeatureSource.AddFeature(multipoint);
            Map1.EditOverlay.FeatureSource.CommitTransaction();
            if (Map1.EditOverlay.FeatureSource.IsOpen) Map1.EditOverlay.FeatureSource.Close();
            
            Map1.CurrentExtent = multipoint.GetBoundingBox();
        }

    }

}
